/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is XXXXX.java
 *
 * The Initial Developer of the Original Code is
 * XXXXX, Freie Universität Berlin, Botanic Garden and Botanical Museum Berlin-Dahlem,
 * Dept. of Biodiversity Informatics and Laboratories
 *
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */

package feedback;

import java.io.Serializable;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

/**
 * <p>Title: </p>
 * <p>Description:</p>
 * @author Cristian Oancea, BGBM
 * @version 1.0, September 2006 
 */

public class CormInfo implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = -9042548598628243282L;
	private Connection dbConn;
	private org.apache.log4j.Logger logger;
	private Config conf;
	
	/** Creates a new instance of UserInfo */
	public CormInfo(org.apache.log4j.Logger logger2, Config config) {
		this.conf = config;
		this.logger = logger2;
	}
	
	public void setConn(Connection dbConn) {

		this.dbConn = dbConn;
	}

	public Config getConf() {
		return conf;
	}
	
	/**
	 * 
	 * @param email
	 * @return
	 */
	public synchronized String getCormUDDI(
			String url,String protocol) {
		String uddi = null;
		String url_new=null;
		
		if (protocol.equalsIgnoreCase("biocase")) 
		{
			url_new=url;
		}
		if (protocol.equalsIgnoreCase("digir"))
		{
			url_new=url.substring(url.indexOf("@")+1);
		}
		
		try {
			//uddi_binding_key
			String sql = "select uddi_binding_key from registry.datasource where access_point='"
				+ url_new + "'";
//			String sql = "select uddi_service_key from registry.datasource where access_point='"
//										+ url_new + "'";
			Statement st = dbConn.createStatement();
			ResultSet rs = st.executeQuery(sql);

			if (rs.next() == true) {
				//uddi = rs.getString("uddi_service_key");
				uddi = rs.getString("uddi_binding_key");
			}
			rs.close();
			st.close();
		} catch (SQLException e) {
			e.printStackTrace();
			logger.error("Annotation DB: Error to query the uddi");
		}
		return uddi;
	}
}
