package feedback;

import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

import org.apache.log4j.Logger;

import HTTPClient.CookieModule;
import HTTPClient.HTTPConnection;
import HTTPClient.HTTPResponse;
import HTTPClient.ModuleException;
import HTTPClient.NVPair;
import HTTPClient.ParseException;
import HTTPClient.ProtocolNotSuppException;

public class MetadataQuery {
	private Logger logger;
	private String urlString;
	private int timeout;
	private URL url;
	private String cgiScriptPath; // path to the wrapper url within the domain
	
	public MetadataQuery(Logger _logger,String _urlString,int _timeout) {
		this.logger = _logger;
		this.urlString = _urlString;
		this.timeout = _timeout;
		CookieModule.setCookiePolicyHandler(null);
		try {

			this.url = new URL(urlString);
			cgiScriptPath = this.url.getPath();
			if (this.url.getQuery() != null) {
				cgiScriptPath = cgiScriptPath + "?" + this.url.getQuery();
			}
			int index = (this.url.toString()).lastIndexOf(cgiScriptPath);
			urlString = this.url.toString().substring(0, index);
		} catch (MalformedURLException e) {
			System.out.println("URL seems to be malformed (" + url + ").");

			e.printStackTrace();
		}
	}
	
	public String getMetadata () {
		String response ="";
		try {
			logger.info("query provider for metadata");
			HTTPConnection con = new HTTPConnection(new URL(urlString));
			con.setTimeout(this.timeout);
			NVPair queryData[] = new NVPair[1];
			queryData[0] = new NVPair("query", "");
			HTTPResponse rsp = con.Post(cgiScriptPath, queryData);
			
			if (rsp.getStatusCode() >= 300) {
				// some logging should be implemented here
				// System.out.println("connection Error");
				logger.error( " HTTP connection Error 300");
			} else {
				response = rsp.getText();
				
			}
			
		} catch (ProtocolNotSuppException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ModuleException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return response;
	}
}
