package feedback;

/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is ValidateErrorChecker.java
 *
 * The Initial Developer of the Original Code is
 * Jinling Li, Freie Universit�t Berlin, ZE Botanischer Garten und Botanisches Museum
 * Berlin-Dahlem .
 *
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * ***** END LICENSE BLOCK ***** */

import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXParseException;

/**
 * <p>
 * Title: ValidateErrorChecker
 * </p>
 * <p>
 * Description: Message for validating
 * </p>
 * <p>
 * August, 2005
 * </p>
 * <p>
 * Company: Botanic Garden and Botanical Museum Berlin-Dahlem
 * </p>
 * 
 * @author Jinling Li
 * @version 1.0
 */

public class ValidateErrorChecker implements ErrorHandler {

	private Validator v;

	public ValidateErrorChecker(Validator v) {

		this.v = v;

	}

	public void warning(SAXParseException exception) {
		// Ignore warnings
	}

	public void error(SAXParseException e) {
		// A validity error.
		// System.out.println("Vaidation error: " + e.getMessage());

		v.setValidationMessage(e.getMessage());
	}

	public void fatalError(SAXParseException e) {
		// A well-formedness error
		// System.out.println("Fatal error: " + e.getMessage());
		v.setfatalErrorMessage(e.getMessage());
	}

}
