/*******************************************************************************
 * Copyright (c) 2001, 2004 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package feedback.svn;

import java.util.logging.Level;
import java.util.logging.Logger;

import org.tmatesoft.svn.core.SVNException;
import org.tmatesoft.svn.core.SVNNodeKind;
import org.tmatesoft.svn.core.SVNURL;
import org.tmatesoft.svn.core.auth.ISVNAuthenticationManager;
import org.tmatesoft.svn.core.internal.io.svn.SVNRepositoryFactoryImpl;
import org.tmatesoft.svn.core.io.SVNRepositoryFactory;
import org.tmatesoft.svn.core.io.SVNRepository;
import org.tmatesoft.svn.core.wc.SVNWCUtil;

import feedback.Config;


public  class SVNController {

	private Logger logger;
	private SVNURL url;
	private Config config;
	private SVNRepository repository;
	private String SVNusername;
	private String SVNuserpassword;
	SVNNodeKind nodeKind;
	
	public SVNController(Logger logger,Config config)
	{
		this.logger=logger;
		this.config = config;
	}
	
	public  void SVNConnect()
	{
		try {
			SVNRepositoryFactoryImpl.setup();
			url = SVNURL.parseURIEncoded(config.getSVNhost());
			SVNusername=config.getSVNUsername();
			SVNuserpassword=config.getSVNPassword();
			repository = SVNRepositoryFactory.create(url);
			logger.log(Level.INFO,"Repository Object Created");
			 ISVNAuthenticationManager authManager = 
				 SVNWCUtil.createDefaultAuthenticationManager(SVNusername, SVNuserpassword);
		     repository.setAuthenticationManager(authManager);
		     logger.log(Level.INFO,"SVN Repository authentification");
		     
		      nodeKind = repository.checkPath("", -1);
		     
		} catch (SVNException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			logger.log(Level.SEVERE,e.getMessage());
		}
		
	}
	
	public void SVNCommitFile()
	{
		
	}
}
